<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: tivx_target_kernel.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
<h1>tivx_target_kernel.h</h1><a href="tivx__target__kernel_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="preprocessor">#ifndef TIVX_TARGET_KERNEL_H_</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#define TIVX_TARGET_KERNEL_H_</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00077"></a>00077 <span class="preprocessor">#include &lt;<a class="code" href="tivx__obj__desc_8h.html" title="Interface to object descriptor.">TI/tivx_obj_desc.h</a>&gt;</span>
<a name="l00078"></a>00078 
<a name="l00083"></a><a class="code" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a">00083</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_tivx_target_kernel *<a class="code" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a" title="Handle to kernel on a target.">tivx_target_kernel</a>;
<a name="l00084"></a>00084 
<a name="l00089"></a><a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8">00089</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_tivx_target_kernel_instance *<a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8" title="Handle to instance of kernel on a target.">tivx_target_kernel_instance</a>;
<a name="l00090"></a>00090 
<a name="l00107"></a><a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569">00107</a> <span class="keyword">typedef</span> <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a>(<a class="code" href="vx__types_8h.html#af22acf717e04b29aa5b836a1097f7181">VX_CALLBACK</a> *<a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a>)(tivx_target_kernel_instance kernel, <a class="code" href="structtivx__obj__desc__t.html" title="Object descriptor.">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params, <span class="keywordtype">void</span> *priv_arg);
<a name="l00108"></a>00108 
<a name="l00124"></a>00124 VX_API_ENTRY tivx_target_kernel <a class="code" href="vx__types_8h.html#aafbf3083f20518b915e89d73e26fe237">VX_API_CALL</a> <a class="code" href="group__group__tivx__target__kernel.html#gac53ae87502b370754a0ae41a1941675a" title="Allows users to add native kernels implementation to specific targets.">tivxAddTargetKernel</a>(
<a name="l00125"></a>00125                              <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> kernel_id,
<a name="l00126"></a>00126                              <span class="keywordtype">char</span> *target_name,
<a name="l00127"></a>00127                              <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> process_func,
<a name="l00128"></a>00128                              <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> create_func,
<a name="l00129"></a>00129                              <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> delete_func,
<a name="l00130"></a>00130                              <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> control_func,
<a name="l00131"></a>00131                              <span class="keywordtype">void</span> *priv_arg);
<a name="l00132"></a>00132 
<a name="l00139"></a>00139 VX_API_ENTRY <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="vx__types_8h.html#aafbf3083f20518b915e89d73e26fe237">VX_API_CALL</a> <a class="code" href="group__group__tivx__target__kernel.html#ga857faf8c07c3ee28fa55d7657176447e" title="Allows users to remove native kernels implementation to specific targets.">tivxRemoveTargetKernel</a>(
<a name="l00140"></a>00140     tivx_target_kernel target_kernel);
<a name="l00141"></a>00141 
<a name="l00149"></a>00149 VX_API_ENTRY <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="vx__types_8h.html#aafbf3083f20518b915e89d73e26fe237">VX_API_CALL</a> <a class="code" href="group__group__tivx__target__kernel.html#ga551f7060ce2a7e3007424a1da2b184a9" title="Associate a kernel function context or handle with a target kernel instance.">tivxSetTargetKernelInstanceContext</a>(
<a name="l00150"></a>00150             tivx_target_kernel_instance target_kernel_instance,
<a name="l00151"></a>00151             <span class="keywordtype">void</span> *kernel_context, uint32_t kernel_context_size);
<a name="l00152"></a>00152 
<a name="l00160"></a>00160 VX_API_ENTRY <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="vx__types_8h.html#aafbf3083f20518b915e89d73e26fe237">VX_API_CALL</a> <a class="code" href="group__group__tivx__target__kernel.html#ga08730671086c805df9f4e00d4a4ef383" title="Get a kernel function context or handle with a target kernel instance.">tivxGetTargetKernelInstanceContext</a>(
<a name="l00161"></a>00161             tivx_target_kernel_instance target_kernel_instance,
<a name="l00162"></a>00162             <span class="keywordtype">void</span> **kernel_context, uint32_t *kernel_context_size);
<a name="l00163"></a>00163 
<a name="l00171"></a>00171 VX_API_ENTRY <span class="keywordtype">void</span> <a class="code" href="group__group__tivx__target__kernel.html#gac6174a4e92a4bf4a19ab77a78963ddf5" title="Get the border mode for the target kernel instance.">tivxGetTargetKernelInstanceBorderMode</a>(
<a name="l00172"></a>00172     tivx_target_kernel_instance target_kernel_instance,
<a name="l00173"></a>00173     <a class="code" href="structvx__border__t.html" title="Use with the enumeration VX_NODE_BORDER to set the border mode behavior of a node...">vx_border_t</a> *border_mode);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>}
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
